"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classnames = _interopRequireDefault(require("classnames"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Transition = _interopRequireWildcard(require("react-transition-group/Transition"));
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
const propTypes = {
  /**
   * Show the component; triggers the fade in or fade out animation
   */
  in: _propTypes.default.bool,
  /**
   * Wait until the first "enter" transition to mount the component (add it to the DOM)
   */
  mountOnEnter: _propTypes.default.bool,
  /**
   * Unmount the component (remove it from the DOM) when it is faded out
   */
  unmountOnExit: _propTypes.default.bool,
  /**
   * Run the fade in animation when the component mounts, if it is initially
   * shown
   */
  appear: _propTypes.default.bool,
  /**
   * Duration of the fade animation in milliseconds, to ensure that finishing
   * callbacks are fired even if the original browser transition end events are
   * canceled
   */
  timeout: _propTypes.default.number,
  /**
   * Callback fired before the component fades in
   */
  onEnter: _propTypes.default.func,
  /**
   * Callback fired after the component starts to fade in
   */
  onEntering: _propTypes.default.func,
  /**
   * Callback fired after the has component faded in
   */
  onEntered: _propTypes.default.func,
  /**
   * Callback fired before the component fades out
   */
  onExit: _propTypes.default.func,
  /**
   * Callback fired after the component starts to fade out
   */
  onExiting: _propTypes.default.func,
  /**
   * Callback fired after the component has faded out
   */
  onExited: _propTypes.default.func
};
const defaultProps = {
  in: false,
  timeout: 300,
  mountOnEnter: false,
  unmountOnExit: false,
  appear: false
};
const fadeStyles = {
  [_Transition.ENTERING]: 'in',
  [_Transition.ENTERED]: 'in'
};
class Fade extends _react.default.Component {
  render() {
    const {
      className,
      children,
      ...props
    } = this.props;
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Transition.default, {
      ...props,
      children: (status, innerProps) => /*#__PURE__*/_react.default.cloneElement(children, {
        ...innerProps,
        className: (0, _classnames.default)('fade', className, children.props.className, fadeStyles[status])
      })
    });
  }
}
Fade.propTypes = propTypes;
Fade.defaultProps = defaultProps;
var _default = exports.default = Fade;
//# sourceMappingURL=Fade.js.map