"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classnames = _interopRequireDefault(require("classnames"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Overlay = _interopRequireDefault(require("react-overlays/lib/Overlay"));
var _elementType = _interopRequireDefault(require("prop-types-extra/lib/elementType"));
var _Fade = _interopRequireDefault(require("./Fade"));
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
const propTypes = {
  ..._Overlay.default.propTypes,
  /**
   * Set the visibility of the Overlay
   */
  show: _propTypes.default.bool,
  /**
   * Specify whether the overlay should trigger onHide when the user clicks outside the overlay
   */
  rootClose: _propTypes.default.bool,
  /**
   * A callback invoked by the overlay when it wishes to be hidden. Required if
   * `rootClose` is specified.
   */
  onHide: _propTypes.default.func,
  /**
   * Use animation
   */
  animation: _propTypes.default.oneOfType([_propTypes.default.bool, _elementType.default]),
  /**
   * Callback fired before the Overlay transitions in
   */
  onEnter: _propTypes.default.func,
  /**
   * Callback fired as the Overlay begins to transition in
   */
  onEntering: _propTypes.default.func,
  /**
   * Callback fired after the Overlay finishes transitioning in
   */
  onEntered: _propTypes.default.func,
  /**
   * Callback fired right before the Overlay transitions out
   */
  onExit: _propTypes.default.func,
  /**
   * Callback fired as the Overlay begins to transition out
   */
  onExiting: _propTypes.default.func,
  /**
   * Callback fired after the Overlay finishes transitioning out
   */
  onExited: _propTypes.default.func,
  /**
   * Sets the direction of the Overlay.
   */
  placement: _propTypes.default.oneOf(['top', 'right', 'bottom', 'left'])
};
const defaultProps = {
  animation: _Fade.default,
  rootClose: false,
  show: false,
  placement: 'right'
};
class Overlay extends _react.default.Component {
  render() {
    const {
      animation,
      children,
      ...props
    } = this.props;
    const transition = animation === true ? _Fade.default : animation || null;
    let child;
    if (!transition) {
      child = /*#__PURE__*/(0, _react.cloneElement)(children, {
        className: (0, _classnames.default)(children.props.className, 'in')
      });
    } else {
      child = children;
    }
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Overlay.default, {
      ...props,
      transition: transition,
      children: child
    });
  }
}
Overlay.propTypes = propTypes;
Overlay.defaultProps = defaultProps;
var _default = exports.default = Overlay;
//# sourceMappingURL=Overlay.js.map