"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _classnames = _interopRequireDefault(require("classnames"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _warning = _interopRequireDefault(require("warning"));
var _bootstrapUtils = require("./utils/bootstrapUtils");
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
// TODO: This should probably take a single `aspectRatio` prop.
const propTypes = {
  /**
   * This component requires a single child element
   */
  children: _propTypes.default.element.isRequired,
  /**
   * 16by9 aspect ratio
   */
  a16by9: _propTypes.default.bool,
  /**
   * 4by3 aspect ratio
   */
  a4by3: _propTypes.default.bool
};
const defaultProps = {
  a16by9: false,
  a4by3: false
};
class ResponsiveEmbed extends _react.default.Component {
  render() {
    const {
      a16by9,
      a4by3,
      className,
      children,
      ...props
    } = this.props;
    const [bsProps, elementProps] = (0, _bootstrapUtils.splitBsProps)(props);
    (0, _warning.default)(a16by9 || a4by3, 'Either `a16by9` or `a4by3` must be set.');
    (0, _warning.default)(!(a16by9 && a4by3), 'Only one of `a16by9` or `a4by3` can be set.');
    const classes = {
      ...(0, _bootstrapUtils.getClassSet)(bsProps),
      [(0, _bootstrapUtils.prefix)(bsProps, '16by9')]: a16by9,
      [(0, _bootstrapUtils.prefix)(bsProps, '4by3')]: a4by3
    };
    return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: (0, _classnames.default)(classes),
      children: /*#__PURE__*/(0, _react.cloneElement)(children, {
        ...elementProps,
        className: (0, _classnames.default)(className, (0, _bootstrapUtils.prefix)(bsProps, 'item'))
      })
    });
  }
}
ResponsiveEmbed.propTypes = propTypes;
ResponsiveEmbed.defaultProps = defaultProps;
var _default = exports.default = (0, _bootstrapUtils.bsClass)('embed-responsive', ResponsiveEmbed);
//# sourceMappingURL=ResponsiveEmbed.js.map